VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsRegister"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.
'
'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !
'

Option Explicit

Private Declare Function FreeLibrary Lib "kernel32" (ByVal _
        hLibModule As Long) As Long
        
Private Declare Function LoadLibrary Lib "kernel32" Alias _
        "LoadLibraryA" (ByVal lpLibFileName As String) As Long
        
Private Declare Function GetProcAddress Lib "kernel32" (ByVal _
        hModule As Long, ByVal lpProcName As String) As Long

Private Declare Function CallWindowProc Lib "user32" Alias _
        "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal _
        hWnd As Long, ByVal Msg As Any, ByVal wParam As Any, _
        ByVal lParam As Any) As Long

Private Declare Function LoadTypeLib Lib "oleaut32.dll" _
        (pFileName As Byte, pptlib As Object) As Long
        
Private Declare Function RegisterTypelib Lib "oleaut32.dll" _
        Alias "RegisterTypeLib" (ByVal ptlib As Object, _
        szFullPath As Byte, szHelpFile As Byte) As Long
        
Private Declare Function UnRegisterTypeLib Lib "oleaut32.dll" _
        (libID As GUID, ByVal wVerMajor As Integer, ByVal _
        wVerMinor As Integer, ByVal lCID As Long, ByVal _
        tSysKind As eSYSKIND) As Long

Private Declare Function CLSIDFromString Lib "ole32.dll" _
        (lpsz As Byte, pclsid As GUID) As Long

Private Declare Function GetShortPathName Lib "kernel32" _
        Alias "GetShortPathNameA" (ByVal lpszLongPath As _
        String, ByVal lpszShortPath As String, ByVal _
        cchBuffer As Long) As Long
        
Private Const ERROR_SUCCESS = &H0

Private Enum eSYSKIND
   SYS_WIN16 = 0
   SYS_WIN32 = 1
   SYS_MAC = 2
End Enum

Private Type GUID
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(0 To 7) As Byte
End Type

Public Function Register(ByRef hWnd As Long, ByRef ComponentPath As String) As Boolean
    Dim Extension As String, Path As String
    
        If FileExists(ComponentPath) Then
            Extension = LCase(Right$(ComponentPath, 4))
            
            If Extension = ".tlb" Then
                Register = RegisterLib(ComponentPath, True)
            ElseIf Extension = ".exe" Then
                Path = GetShortPath(ComponentPath) & " /regserver"
                Shell Path
                Register = True
            ElseIf Extension = ".dll" Or Extension = ".ocx" Then
                Register = RegisterServer(hWnd, ComponentPath, True)
            End If
        End If
End Function

Public Function Unregister(ByRef hWnd As Long, ByRef ComponentPath As String) As Boolean
    Dim Extension As String, Path As String
    
        If FileExists(ComponentPath) Then
            Extension = LCase(Right$(ComponentPath, 4))
            
            If Extension = ".tlb" Then
                Unregister = RegisterLib(ComponentPath, False)
            ElseIf Extension = ".exe" Then
                Path = GetShortPath(ComponentPath) & " /unregserver"
                Shell Path
                Unregister = True
            ElseIf Extension = ".dll" Or Extension = ".ocx" Then
                Unregister = RegisterServer(hWnd, ComponentPath, False)
            End If
        End If
End Function

Private Function RegisterServer(ByRef hWnd As Long, ByRef ComponentPath As String, ByRef Mode As Boolean) As Boolean
    Dim Lib As Long, Prc As Long, Fnc As String
    
        Lib = LoadLibrary(ComponentPath)
        Fnc = IIf(Mode, "DllRegisterServer", "DllUnregisterServer")
        Prc = GetProcAddress(Lib, Fnc)

        RegisterServer = (CallWindowProc(Prc, hWnd, ByVal 0&, ByVal 0&, ByVal 0&) = ERROR_SUCCESS)
        Call FreeLibrary(Lib)
End Function

Private Function RegisterLib(ByRef ComponentPath As String, ByVal Mode As Boolean) As Boolean
    Dim cTLI As TypeLibInfo, tGUID As GUID
    Dim suLib() As Byte, Tlb As Object
    
        If Mode Then
            suLib = ComponentPath & vbNullChar
            
            If (LoadTypeLib(suLib(0), Tlb) = ERROR_SUCCESS) Then
                RegisterLib = (RegisterTypelib(Tlb, suLib(0), 0) = ERROR_SUCCESS)
            End If
        Else

            Set cTLI = TLI.TypeLibInfoFromFile(ComponentPath)
            suLib = cTLI.GUID & vbNullChar
            
            If (CLSIDFromString(suLib(0), tGUID) = ERROR_SUCCESS) Then
                RegisterLib = (UnRegisterTypeLib(tGUID, _
                                                 cTLI.MajorVersion, _
                                                 cTLI.MinorVersion, _
                                                 cTLI.lCID, _
                                                 SYS_WIN32) = ERROR_SUCCESS)
            End If
            
            Set cTLI = Nothing
        End If
   
End Function

Private Function GetShortPath(ByRef Path As String) As String
    Dim Result As Long, aa As String
        
        aa = Space$(255)
        Result = GetShortPathName(Path, aa, Len(aa))
        GetShortPath = Mid$(aa, 1, Result)
End Function

Private Function FileExists(ByVal FileName As String) As Boolean
    On Error GoTo Err
    
    If Dir$(FileName) <> "" Then FileExists = True
Err:
 
End Function
